Index: trunk/kBuild/tools/VCC70.kmk
===================================================================
--- trunk/kBuild/tools/VCC70.kmk	(revision 432)
+++ trunk/kBuild/tools/VCC70.kmk	(revision 434)
@@ -88,5 +88,5 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC70_COMPILE_C_OUTPUT	= $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb) 
+TOOL_VCC70_COMPILE_C_OUTPUT	= $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
 TOOL_VCC70_COMPILE_C_DEPEND	=
 TOOL_VCC70_COMPILE_C_DEPORD =
@@ -129,5 +129,5 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb) 
+TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
 TOOL_VCC70_COMPILE_CXX_DEPEND =
 TOOL_VCC70_COMPILE_CXX_DEPORD =
@@ -196,5 +196,5 @@
 	$(TOOL_VCC70_LD) $(flags) \
 		/OUT:$(out) \
-		/MAPINFO:EXPORTS /MAPINFO:LINES \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
 		/MAP:$(outbase).map \
 		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
@@ -227,5 +227,5 @@
 		/OUT:$(out) \
 		/IMPLIB:$(outbase).lib \
-		/MAPINFO:EXPORTS /MAPINFO:LINES \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
 		/MAP:$(outbase).map \
 		/DLL \
@@ -263,5 +263,5 @@
 	$(TOOL_VCC70_LD) $(flags) \
 		/OUT:$(out) \
-		/MAPINFO:EXPORTS /MAPINFO:LINES \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
 		/MAP:$(outbase).map \
 		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
Index: trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC80AMD64.kmk	(revision 434)
+++ trunk/kBuild/tools/VCC80AMD64.kmk	(revision 434)
@@ -0,0 +1,278 @@
+# $Id$
+## @file
+#
+# kBuild Tool Config - Visual C++ 8.0 (aka Visual .NET 2005)
+#
+# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+TOOL_VCC80AMD64                    := Visual C++ 8.0 AMD64
+PATH_TOOL_VCC80AMD64               ?= $(PATH_DEV)/x86.win32/vcc80
+PATH_TOOL_VCC80AMD64_LIB           ?= $(PATH_DEV)/x86.win32/vcc80/lib
+ifeq ($(BUILD_PLATFORM),win64
+PATH_TOOL_VCC80AMD64_BIN           ?= $(PATH_DEV)/x86.win32/vcc80/amd64/bin
+else
+PATH_TOOL_VCC80AMD64_BIN           ?= $(PATH_DEV)/x86.win32/vcc80/x86_amd64/bin
+endif
+
+TOOL_VCC80AMD64_CC                 := $(EXEC_AMD64_WIN32) $(PATH_TOOL_VCC80AMD64_BIN)/cl.exe
+TOOL_VCC80AMD64_COBJSUFF           := .obj
+TOOL_VCC80AMD64_CFLAGS             := -TC -c -nologo
+TOOL_VCC80AMD64_CFLAGS.debug       := -Od -Zi
+TOOL_VCC80AMD64_CFLAGS.release     := -O2
+TOOL_VCC80AMD64_CFLAGS.profile     := -O2
+TOOL_VCC80AMD64_CINCS              := $(PATH_TOOL_VCC80AMD64)/include
+TOOL_VCC80AMD64_CDEFS              :=
+
+TOOL_VCC80AMD64_CXX                := $(EXEC_AMD64_WIN32) $(PATH_TOOL_VCC80AMD64_BIN)/cl.exe
+TOOL_VCC80AMD64_CXXOBJSUFF         := .obj
+TOOL_VCC80AMD64_CXXFLAGS           := -TP -c -nologo
+TOOL_VCC80AMD64_CXXFLAGS.debug     := -Od -Zi
+TOOL_VCC80AMD64_CXXFLAGS.release   := -O2
+TOOL_VCC80AMD64_CXXFLAGS.profile   := -O2
+TOOL_VCC80AMD64_CXXINCS            := $(PATH_TOOL_VCC80AMD64)/include
+TOOL_VCC80AMD64_CXXDEFS            :=
+
+TOOL_VCC80AMD64_AS                 := $(EXEC_AMD64_WIN32) $(PATH_TOOL_VCC80AMD64_BIN)/ml.exe
+TOOL_VCC80AMD64_ASOBJSUFF          := .obj
+
+TOOL_VCC80AMD64_AR                 := $(EXEC_AMD64_WIN32) $(PATH_TOOL_VCC80AMD64_BIN)/lib.exe
+TOOL_VCC80AMD64_ARFLAGS            := -nologo
+TOOL_VCC80AMD64_ARLIBSUFF          := .lib
+
+TOOL_VCC80AMD64_LD                 := $(EXEC_AMD64_WIN32) $(PATH_TOOL_VCC80AMD64_BIN)/link.exe
+TOOL_VCC80AMD64_LDFLAGS            := -nologo
+TOOL_VCC80AMD64_LDFLAGS.debug      := -debug
+TOOL_VCC80AMD64_LDFLAGS.release    :=
+
+## Constructs the correct .pdb name (the name is lowercased).
+# @param    $(1)        Base name, no extention.
+# @param    $(2)        The extension.
+ifeq ($(filter tolower,$(KMK_FEATURES)),tolower)
+TOOL_VCC80AMD64_PDB                = $(dir $(1))$(tolower $(notdir $(1))).$(2)
+else # this fallback is incorrect and won't work on a case sensitive FS.
+TOOL_VCC80AMD64_PDB                = $(1).$(2)
+endif
+
+#ifeq ($(BUILD_PLATFORM),win32)
+VCC80AMD64_NEW_DEPS = 1
+#endif
+
+
+
+## Compile C source.
+# @param    $(target)   Normalized main target name.
+# @param    $(source)   Source filename (relative).
+# @param    $(obj)      Object file name. This shall be (re)created by the compilation.
+# @param    $(dep)      Dependcy file. This shall be (re)created by the compilation.
+# @param    $(flags)    Flags.
+# @param    $(defs)     Definitions. No -D or something.
+# @param    $(incs)     Includes. No -I or something.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+# @param    $(objsuff)  Object suffix.
+TOOL_VCC80AMD64_COMPILE_C_OUTPUT	= $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_C_DEPEND	=
+TOOL_VCC80AMD64_COMPILE_C_DEPORD =
+ifdef VCC80AMD64_NEW_DEPS
+define TOOL_VCC80AMD64_COMPILE_C_CMDS
+	$(TOOL_VCC80AMD64_CC) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-FD\
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80AMD64_PDB,$(outbase)-obj,idb)
+endef
+else
+define TOOL_VCC80AMD64_COMPILE_C_CMDS
+	$(TOOL_VCC80AMD64_CC) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(TOOL_VCC80AMD64_CC) -E\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(subst /,\\,$(call ABSPATH,$(source)))\
+		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
+endef
+endif
+
+
+## Compile C++ source.
+# @param    $(target)   Normalized main target name.
+# @param    $(source)   Source filename (relative).
+# @param    $(obj)      Object file name. This shall be (re)created by the compilation.
+# @param    $(dep)      Dependcy file. This shall be (re)created by the compilation.
+# @param    $(flags)    Flags.
+# @param    $(defs)     Definitions. No -D or something.
+# @param    $(incs)     Includes. No -I or something.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+# @param    $(objsuff)  Object suffix.
+TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_CXX_DEPEND =
+TOOL_VCC80AMD64_COMPILE_CXX_DEPORD =
+ifdef VCC80AMD64_NEW_DEPS
+define TOOL_VCC80AMD64_COMPILE_CXX_CMDS
+	$(TOOL_VCC80AMD64_CXX) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-FD\
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80AMD64_PDB,$(outbase)-obj,idb)
+endef
+else
+define TOOL_VCC80AMD64_COMPILE_CXX_CMDS
+	$(TOOL_VCC80AMD64_CXX) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(TOOL_VCC80AMD64_CXX) -E\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(subst /,\\,$(call ABSPATH,$(source)))\
+		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
+endef
+endif
+
+
+## Link library
+# @param    $(target)   Normalized main target name.
+# @param    $(out)      Library name.
+# @param    $(objs)     Object files to put in the library.
+# @param    $(flags)    Flags.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+# @param    $(othersrc) Unhandled sources.
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+#
+TOOL_VCC80AMD64_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(call TOOL_VCC80AMD64_PDB, $(outbase),pdb)
+TOOL_VCC80AMD64_LINK_LIBRARY_DEPEND = $(othersrc)
+TOOL_VCC80AMD64_LINK_LIBRARY_DEPORD =
+define TOOL_VCC80AMD64_LINK_LIBRARY_CMDS
+	$(TOOL_VCC80AMD64_AR) $(flags) /OUT:$(out) $(subst /,\\,$(objs) $(filter %.a %.lib,$(othersrc))) \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def))
+endef
+
+
+## Link program
+# @param    $(target)       Normalized main target name.
+# @param    $(out)          Program name.
+# @param    $(objs)         Object files to link together.
+# @param    $(libs)         Libraries to search.
+# @param    $(libpath)      Library search paths.
+# @param    $(flags)        Flags.
+# @param    $(dirdep)       Directory creation dependency.
+# @param    $(deps)         Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+# @param    $(outbase)      Output basename (full). Use this for list files and such.
+#
+TOOL_VCC80AMD64_LINK_PROGRAM_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80AMD64_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80AMD64_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80AMD64_LINK_PROGRAM_DEPORD =
+define TOOL_VCC80AMD64_LINK_PROGRAM_CMDS
+	$(TOOL_VCC80AMD64_LD) $(flags) \
+		/OUT:$(out) \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+endef
+
+
+## Link DLL.
+# @param    $(target)   Normalized main target name.
+# @param    $(out)      DLL name.
+# @param    $(objs)     Object files to link together.
+# @param    $(libs)     Libraries to search.
+# @param    $(libpath)  Library search paths.
+# @param    $(flags)    Flags.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+TOOL_VCC80AMD64_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80AMD64_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80AMD64_LINK_DLL_DEPEND = $(objs) $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80AMD64_LINK_DLL_DEPORD = $(call DIRDEP,$(PATH_LIB))
+define TOOL_VCC80AMD64_LINK_DLL_CMDS
+	$(TOOL_VCC80AMD64_LD) $(flags) \
+		/OUT:$(out) \
+		/IMPLIB:$(outbase).lib \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		/DLL \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+ifeq ($(filter %.exp .def,$(othersrc)),)
+	if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
+	if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
+endif
+$(eval _DIRS += $(PATH_LIB))
+endef
+
+
+## Link system module (windows aka driver, linux aka kernel module)
+# @param    $(target)       Normalized main target name.
+# @param    $(out)          System module name.
+# @param    $(objs)         Object files to link together.
+# @param    $(libs)         Libraries to search.
+# @param    $(libpath)      Library search paths.
+# @param    $(flags)        Flags.
+# @param    $(dirdep)       Directory creation dependency.
+# @param    $(deps)         Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+TOOL_VCC80AMD64_LINK_SYSMOD_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80AMD64_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80AMD64_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80AMD64_LINK_SYSMOD_DEPORD =
+define TOOL_VCC80AMD64_LINK_SYSMOD_CMDS
+	$(TOOL_VCC80AMD64_LD) $(flags) \
+		/OUT:$(out) \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+endef
+
Index: trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC80X86.kmk	(revision 434)
+++ trunk/kBuild/tools/VCC80X86.kmk	(revision 434)
@@ -0,0 +1,274 @@
+# $Id$
+## @file
+#
+# kBuild Tool Config - Visual C++ 8.0 (aka Visual .NET 2005)
+#
+# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+TOOL_VCC80X86                    := Visual C++ 8.0 x86
+PATH_TOOL_VCC80X86               ?= $(PATH_DEV)/x86.win32/vcc80
+PATH_TOOL_VCC80X86_LIB           ?= $(PATH_DEV)/x86.win32/vcc80/lib
+PATH_TOOL_VCC80X86_BIN           ?= $(PATH_DEV)/x86.win32/vcc80/bin
+
+TOOL_VCC80X86_CC                 := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC80X86_BIN)/cl.exe
+TOOL_VCC80X86_COBJSUFF           := .obj
+TOOL_VCC80X86_CFLAGS             := -TC -c -nologo
+TOOL_VCC80X86_CFLAGS.debug       := -Od -Zi
+TOOL_VCC80X86_CFLAGS.release     := -O2
+TOOL_VCC80X86_CFLAGS.profile     := -O2
+TOOL_VCC80X86_CINCS              := $(PATH_TOOL_VCC80X86)/include
+TOOL_VCC80X86_CDEFS              :=
+
+TOOL_VCC80X86_CXX                := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC80X86_BIN)/cl.exe
+TOOL_VCC80X86_CXXOBJSUFF         := .obj
+TOOL_VCC80X86_CXXFLAGS           := -TP -c -nologo
+TOOL_VCC80X86_CXXFLAGS.debug     := -Od -Zi
+TOOL_VCC80X86_CXXFLAGS.release   := -O2
+TOOL_VCC80X86_CXXFLAGS.profile   := -O2
+TOOL_VCC80X86_CXXINCS            := $(PATH_TOOL_VCC80X86)/include
+TOOL_VCC80X86_CXXDEFS            :=
+
+TOOL_VCC80X86_AS                 := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC80X86_BIN)/ml.exe
+TOOL_VCC80X86_ASOBJSUFF          := .obj
+
+TOOL_VCC80X86_AR                 := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC80X86_BIN)/lib.exe
+TOOL_VCC80X86_ARFLAGS            := -nologo
+TOOL_VCC80X86_ARLIBSUFF          := .lib
+
+TOOL_VCC80X86_LD                 := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC80X86_BIN)/link.exe
+TOOL_VCC80X86_LDFLAGS            := -nologo
+TOOL_VCC80X86_LDFLAGS.debug      := -debug
+TOOL_VCC80X86_LDFLAGS.release    :=
+
+## Constructs the correct .pdb name (the name is lowercased).
+# @param    $(1)        Base name, no extention.
+# @param    $(2)        The extension.
+ifeq ($(filter tolower,$(KMK_FEATURES)),tolower)
+TOOL_VCC80X86_PDB                = $(dir $(1))$(tolower $(notdir $(1))).$(2)
+else # this fallback is incorrect and won't work on a case sensitive FS.
+TOOL_VCC80X86_PDB                = $(1).$(2)
+endif
+
+#ifeq ($(BUILD_PLATFORM),win32)
+VCC80X86_NEW_DEPS = 1
+#endif
+
+
+
+## Compile C source.
+# @param    $(target)   Normalized main target name.
+# @param    $(source)   Source filename (relative).
+# @param    $(obj)      Object file name. This shall be (re)created by the compilation.
+# @param    $(dep)      Dependcy file. This shall be (re)created by the compilation.
+# @param    $(flags)    Flags.
+# @param    $(defs)     Definitions. No -D or something.
+# @param    $(incs)     Includes. No -I or something.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+# @param    $(objsuff)  Object suffix.
+TOOL_VCC80X86_COMPILE_C_OUTPUT	= $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_C_DEPEND	=
+TOOL_VCC80X86_COMPILE_C_DEPORD =
+ifdef VCC80X86_NEW_DEPS
+define TOOL_VCC80X86_COMPILE_C_CMDS
+	$(TOOL_VCC80X86_CC) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-FD\
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80X86_PDB,$(outbase)-obj,idb)
+endef
+else
+define TOOL_VCC80X86_COMPILE_C_CMDS
+	$(TOOL_VCC80X86_CC) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(TOOL_VCC80X86_CC) -E\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(subst /,\\,$(call ABSPATH,$(source)))\
+		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
+endef
+endif
+
+
+## Compile C++ source.
+# @param    $(target)   Normalized main target name.
+# @param    $(source)   Source filename (relative).
+# @param    $(obj)      Object file name. This shall be (re)created by the compilation.
+# @param    $(dep)      Dependcy file. This shall be (re)created by the compilation.
+# @param    $(flags)    Flags.
+# @param    $(defs)     Definitions. No -D or something.
+# @param    $(incs)     Includes. No -I or something.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+# @param    $(objsuff)  Object suffix.
+TOOL_VCC80X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_CXX_DEPEND =
+TOOL_VCC80X86_COMPILE_CXX_DEPORD =
+ifdef VCC80X86_NEW_DEPS
+define TOOL_VCC80X86_COMPILE_CXX_CMDS
+	$(TOOL_VCC80X86_CXX) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-FD\
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80X86_PDB,$(outbase)-obj,idb)
+endef
+else
+define TOOL_VCC80X86_COMPILE_CXX_CMDS
+	$(TOOL_VCC80X86_CXX) -c\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		-Fd$(outbase)-obj.pdb \
+		-Fo$(obj)\
+		$(subst /,\\,$(call ABSPATH,$(source)))
+	$(TOOL_VCC80X86_CXX) -E\
+		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(subst /,\\,$(call ABSPATH,$(source)))\
+		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
+endef
+endif
+
+
+## Link library
+# @param    $(target)   Normalized main target name.
+# @param    $(out)      Library name.
+# @param    $(objs)     Object files to put in the library.
+# @param    $(flags)    Flags.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+# @param    $(othersrc) Unhandled sources.
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+#
+TOOL_VCC80X86_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(call TOOL_VCC80X86_PDB, $(outbase),pdb)
+TOOL_VCC80X86_LINK_LIBRARY_DEPEND = $(othersrc)
+TOOL_VCC80X86_LINK_LIBRARY_DEPORD =
+define TOOL_VCC80X86_LINK_LIBRARY_CMDS
+	$(TOOL_VCC80X86_AR) $(flags) /OUT:$(out) $(subst /,\\,$(objs) $(filter %.a %.lib,$(othersrc))) \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def))
+endef
+
+
+## Link program
+# @param    $(target)       Normalized main target name.
+# @param    $(out)          Program name.
+# @param    $(objs)         Object files to link together.
+# @param    $(libs)         Libraries to search.
+# @param    $(libpath)      Library search paths.
+# @param    $(flags)        Flags.
+# @param    $(dirdep)       Directory creation dependency.
+# @param    $(deps)         Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+# @param    $(outbase)      Output basename (full). Use this for list files and such.
+#
+TOOL_VCC80X86_LINK_PROGRAM_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80X86_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80X86_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80X86_LINK_PROGRAM_DEPORD =
+define TOOL_VCC80X86_LINK_PROGRAM_CMDS
+	$(TOOL_VCC80X86_LD) $(flags) \
+		/OUT:$(out) \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+endef
+
+
+## Link DLL.
+# @param    $(target)   Normalized main target name.
+# @param    $(out)      DLL name.
+# @param    $(objs)     Object files to link together.
+# @param    $(libs)     Libraries to search.
+# @param    $(libpath)  Library search paths.
+# @param    $(flags)    Flags.
+# @param    $(dirdep)   Directory creation dependency.
+# @param    $(deps)     Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+TOOL_VCC80X86_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80X86_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80X86_LINK_DLL_DEPEND = $(objs) $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80X86_LINK_DLL_DEPORD = $(call DIRDEP,$(PATH_LIB))
+define TOOL_VCC80X86_LINK_DLL_CMDS
+	$(TOOL_VCC80X86_LD) $(flags) \
+		/OUT:$(out) \
+		/IMPLIB:$(outbase).lib \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		/DLL \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+ifeq ($(filter %.exp .def,$(othersrc)),)
+	if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
+	if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
+endif
+$(eval _DIRS += $(PATH_LIB))
+endef
+
+
+## Link system module (windows aka driver, linux aka kernel module)
+# @param    $(target)       Normalized main target name.
+# @param    $(out)          System module name.
+# @param    $(objs)         Object files to link together.
+# @param    $(libs)         Libraries to search.
+# @param    $(libpath)      Library search paths.
+# @param    $(flags)        Flags.
+# @param    $(dirdep)       Directory creation dependency.
+# @param    $(deps)         Other dependencies.
+# @param    $(othersrc)     Unhandled sources.
+# @param    $(custom_pre)   Custom step invoked before linking.
+# @param    $(custom_post)  Custom step invoked after linking.
+#
+# @param    $(outbase)  Output basename (full). Use this for list files and such.
+TOOL_VCC80X86_LINK_SYSMOD_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(call TOOL_VCC80X86_PDB, $(outbase),pdb) $(outbase).ilk
+TOOL_VCC80X86_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
+TOOL_VCC80X86_LINK_SYSMOD_DEPORD =
+define TOOL_VCC80X86_LINK_SYSMOD_CMDS
+	$(TOOL_VCC80X86_LD) $(flags) \
+		/OUT:$(out) \
+		/MAPINFO:EXPORTS /INCREMENTAL:NO /MAPINFO:LINES \
+		/MAP:$(outbase).map \
+		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def)) \
+		$(subst /,\\,$(filter %.exp %.res,$(othersrc))) \
+		$(foreach p,$(libpath), /LIBPATH:$(p)) \
+		$(subst /,\\,$(objs)) \
+		$(subst /,\\,$(libs))
+endef
+