Index: trunk/kBuild/sdks/W2K3DDKAMD64.kmk
===================================================================
--- trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 436)
+++ trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 436)
@@ -0,0 +1,40 @@
+# $Id: NT4DDK.kmk 78 2004-06-01 01:07:24Z bird $
+## @file
+#
+# kBuild SDK - Windows 2003 DDK, AMD64.
+#
+# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+SDK_W2K3DDKAMD64          := MicroSoft Windows 2003 DDK, AMD64
+PATH_SDK_W2K3DDKAMD64     := $(PATH_DEV)/x86.win32/nt4ddk
+PATH_SDK_W2K3DDKAMD64_INC := $(PATH_SDK_W2K3DDKAMD64)/inc
+PATH_SDK_W2K3DDKAMD64_LIB := $(PATH_SDK_W2K3DDKAMD64)/lib/wnet/AMD64
+
+SDK_W2K3DDKAMD64_DEFS		:= _AMD64_
+SDK_W2K3DDKAMD64_INCS		:= \
+	$(PATH_SDK_W2K3DDKAMD64_INC)/ddk/wnet \
+	$(PATH_SDK_W2K3DDKAMD64_INC)/wnet \
+	$(PATH_SDK_W2K3DDKAMD64_INC)/ddk/wnet
+
+SDK_W2K3DDKAMD64_LIBPATHS	:= $(PATH_SDK_W2K3DDKAMD64_LIB)
+
Index: trunk/kBuild/sdks/W2K3DDKX86.kmk
===================================================================
--- trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 436)
+++ trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 436)
@@ -0,0 +1,40 @@
+# $Id: NT4DDK.kmk 78 2004-06-01 01:07:24Z bird $
+## @file
+#
+# kBuild SDK - Windows 2003 DDK, X86.
+#
+# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+SDK_W2K3DDKX86          := MicroSoft Windows 2003 DDK, X86
+PATH_SDK_W2K3DDKX86     := $(PATH_DEV)/x86.win32/ddkwin2k3
+PATH_SDK_W2K3DDKX86_INC := $(PATH_SDK_W2K3DDKX86)/inc
+PATH_SDK_W2K3DDKX86_LIB := $(PATH_SDK_W2K3DDKX86)/lib/wnet/i386
+
+SDK_W2K3DDKX86_DEFS		:= _X86_
+SDK_W2K3DDKX86_INCS		:= \
+	$(PATH_SDK_W2K3DDKX86_INC)/ddk/wnet \
+	$(PATH_SDK_W2K3DDKX86_INC)/wnet \
+	$(PATH_SDK_W2K3DDKX86_INC)/ddk/wnet
+
+SDK_W2K3DDKX86_LIBPATHS	:= $(PATH_SDK_W2K3DDKX86_LIB)
+
Index: trunk/kBuild/sdks/WIN32SDK.kmk
===================================================================
--- trunk/kBuild/sdks/WIN32SDK.kmk	(revision 436)
+++ trunk/kBuild/sdks/WIN32SDK.kmk	(revision 436)
@@ -0,0 +1,61 @@
+# $Id: W32API.kmk 132 2004-06-30 20:29:28Z bird $
+## @file
+#
+# kBuild SDK - Windows Platform SDK.
+#
+# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+SDK_WIN32SDK          := Win32 Platform SDK
+ifndef PATH_SDK_WIN32SDK
+PATH_SDK_WIN32SDK     := $(sort $(wildcard $(PATH_DEV)/x86.win32/sdk/2*))
+ifneq ($(PATH_SDK_WIN32SDK),)
+PATH_SDK_WIN32SDK     := $(call lastword,$(PATH_SDK_WIN32SDK))
+endif
+endif
+PATH_SDK_WIN32SDK_INC := $(PATH_SDK_WIN32SDK)/include
+PATH_SDK_WIN32SDK_LIB := $(PATH_SDK_WIN32SDK)/lib
+
+SDK_WIN32SDK_INCS     := $(PATH_SDK_WIN32SDK_INC)
+SDK_WIN32SDK_LIBPATH  := $(PATH_SDK_WIN32SDK_LIB)
+SDK_WIN32SDK_LIBS     := \
+	$(PATH_SDK_WIN32SDK_LIB)/Kernel32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/User32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/Gdi32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/AdvAPI32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/Shell32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/ShLwApi.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/SetupAPI.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/Uuid.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/Version.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WIN32SDK_LIB)/Ole32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/OleAut32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/OleDlg.Lib \
+	\
+	$(PATH_SDK_WIN32SDK_LIB)/DbgHelp.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/ImageHlp.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/ComCtl32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/ComDlg32.Lib \
+	$(PATH_SDK_WIN32SDK_LIB)/WinSpool.Lib \
+
Index: trunk/kBuild/sdks/WIN32SDK2002.kmk
===================================================================
--- trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 436)
+++ trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 436)
@@ -0,0 +1,56 @@
+# $Id: W32API.kmk 132 2004-06-30 20:29:28Z bird $
+## @file
+#
+# kBuild SDK - Windows Platform SDK (2002).
+#
+# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+SDK_WIN32SDK2002          := Win32 Platform SDK 2002
+PATH_SDK_WIN32SDK2002     ?= $(PATH_DEV)/x86.win32/sdk200209
+PATH_SDK_WIN32SDK2002_INC := $(PATH_SDK_WIN32SDK2002)/include
+PATH_SDK_WIN32SDK2002_LIB := $(PATH_SDK_WIN32SDK2002)/lib
+
+SDK_WIN32SDK2002_INCS     := $(PATH_SDK_WIN32SDK2002_INC)
+SDK_WIN32SDK2002_LIBPATH  := $(PATH_SDK_WIN32SDK2002_LIB)
+SDK_WIN32SDK2002_LIBS     := \
+	$(PATH_SDK_WIN32SDK2002_LIB)/Kernel32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/User32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/Gdi32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/AdvAPI32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/Shell32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/ShLwApi.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/SetupAPI.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/Uuid.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/Version.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WIN32SDK2002_LIB)/Ole32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/OleAut32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/OleDlg.Lib \
+	\
+	$(PATH_SDK_WIN32SDK2002_LIB)/DbgHelp.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/ImageHlps.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/ComClt32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/ComDlg32.Lib \
+	$(PATH_SDK_WIN32SDK2002_LIB)/WinSpool.Lib \
+
Index: trunk/kBuild/sdks/WIN64SDK.kmk
===================================================================
--- trunk/kBuild/sdks/WIN64SDK.kmk	(revision 436)
+++ trunk/kBuild/sdks/WIN64SDK.kmk	(revision 436)
@@ -0,0 +1,64 @@
+# $Id: W32API.kmk 132 2004-06-30 20:29:28Z bird $
+## @file
+#
+# kBuild SDK - Windows Platform SDK.
+#
+# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+#
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+
+SDK_WIN64SDK          := Win64 Platform SDK
+ifndef PATH_SDK_WIN64SDK
+PATH_SDK_WIN64SDK     := $(sort $(wildcard $(PATH_DEV)/amd64.win64/sdk/2*)
+ifeq ($(PATH_SDK_WIN64SDK),)
+PATH_SDK_WIN64SDK     := $(sort $(wildcard $(PATH_DEV)/x86.win32/sdk/2*))
+endif
+ifneq ($(PATH_SDK_WIN64SDK),)
+PATH_SDK_WIN64SDK     := $(call lastword,$(PATH_SDK_WIN64SDK))
+endif
+endif
+PATH_SDK_WIN64SDK_INC := $(PATH_SDK_WIN64SDK)/include
+PATH_SDK_WIN64SDK_LIB := $(PATH_SDK_WIN64SDK)/lib/AMD64
+
+SDK_WIN64SDK_INCS     := $(PATH_SDK_WIN64SDK_INC)
+SDK_WIN64SDK_LIBPATH  := $(PATH_SDK_WIN64SDK_LIB)
+SDK_WIN64SDK_LIBS     := \
+	$(PATH_SDK_WIN64SDK_LIB)/Kernel32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/User32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/Gdi32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/AdvAPI32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/Shell32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/ShLwApi.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/SetupAPI.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/Uuid.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/Version.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WIN64SDK_LIB)/Ole32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/OleAut32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/OleDlg.Lib \
+	\
+	$(PATH_SDK_WIN64SDK_LIB)/DbgHelp.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/ImageHlp.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/ComCtl32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/ComDlg32.Lib \
+	$(PATH_SDK_WIN64SDK_LIB)/WinSpool.Lib \
+