Index: trunk/openjdk/hotspot/make/os2/makefiles/vm.make
===================================================================
--- trunk/openjdk/hotspot/make/os2/makefiles/vm.make	(revision 446)
+++ trunk/openjdk/hotspot/make/os2/makefiles/vm.make	(revision 447)
@@ -83,18 +83,18 @@
 AGCT_EXPORT=
 else
-AGCT_EXPORT=_AsyncGetCallTrace \n  AsyncGetCallTrace = _AsyncGetCallTrace \n
+AGCT_EXPORT=_AsyncGetCallTrace\n  AsyncGetCallTrace=_AsyncGetCallTrace\n
 endif
 
 Def_File = vm.def
 $(Def_File): $(MAKEFILE)
-	@printf 'LIBRARY jvm INITINSTANCE TERMINSTANCE \n \
-EXPORTS \n \
-  _jio_snprintf \n \
-  _jio_printf \n \
-  _jio_fprintf \n \
-  _jio_vfprintf \n \
-  _jio_vsnprintf \n \
-  $(AGCT_EXPORT) \
-' > $(Def_File)
+	@printf "LIBRARY jvm INITINSTANCE TERMINSTANCE\n\
+EXPORTS\n\
+  _jio_snprintf\n\
+  _jio_printf\n\
+  _jio_fprintf\n\
+  _jio_vfprintf\n\
+  _jio_vsnprintf\n\
+  $(AGCT_EXPORT)\
+" > $(Def_File)
 
 LINK_FLAGS += -Zdll
Index: trunk/openjdk/jdk/make/java/hpi/windows/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/hpi/windows/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/hpi/windows/Makefile	(revision 447)
@@ -66,16 +66,11 @@
 
 ifeq ($(PLATFORM),os2)
-
 # exports live in .def file
 DEF_FILE = $(OBJDIR)/$(LIBRARY).def
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  DLL_Initialize \n \
-' >> $@
-
+	@$(ECHO) "EXPORTS\n  DLL_Initialize\n" >> $@
 clean::
 	-$(RM) $(DEF_FILE)
-
 endif
 
Index: trunk/openjdk/jdk/make/java/instrument/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/instrument/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/instrument/Makefile	(revision 447)
@@ -129,7 +129,5 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  Agent_OnAttach \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n  Agent_OnAttach\n" >> $@
 clean::
 	-$(RM) $(DEF_FILE)
Index: trunk/openjdk/jdk/make/java/java/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/java/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/java/Makefile	(revision 447)
@@ -56,28 +56,28 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  Canonicalize = _Canonicalize \n \
-  getEncodingFromLangID = _getEncodingFromLangID \n \
-  getJavaIDFromLangID = _getJavaIDFromLangID \n \
-  GetStringPlatformChars = _GetStringPlatformChars \n \
-  _handleLseek \n \
-  _handleRead \n \
-  _handleSync \n \
-  _handleWrite \n \
-  handleLseek = _handleLseek \n \
-  handleRead = _handleRead \n \
-  handleSync = _handleSync \n \
-  handleWrite = _handleWrite \n \
-  JDK_GetVersionInfo0 = _JDK_GetVersionInfo0 \n \
-  _jio_fprintf \n \
-  _jio_snprintf \n \
-  jio_fprintf = _jio_fprintf \n \
-  jio_snprintf = _jio_snprintf \n \
-  NewStringPlatform = _NewStringPlatform \n \
-  VerifyClassCodesForMajorVersion = _VerifyClassCodesForMajorVersion \n \
-  VerifyClassCodes = _VerifyClassCodes \n \
-  _winFileHandleOpen \n \
-  winFileHandleOpen = _winFileHandleOpen \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  Canonicalize = _Canonicalize\n\
+  getEncodingFromLangID = _getEncodingFromLangID\n\
+  getJavaIDFromLangID = _getJavaIDFromLangID\n\
+  GetStringPlatformChars = _GetStringPlatformChars\n\
+  _handleLseek\n\
+  _handleRead\n\
+  _handleSync\n\
+  _handleWrite\n\
+  handleLseek = _handleLseek\n\
+  handleRead = _handleRead\n\
+  handleSync = _handleSync\n\
+  handleWrite = _handleWrite\n\
+  JDK_GetVersionInfo0 = _JDK_GetVersionInfo0\n\
+  _jio_fprintf\n\
+  _jio_snprintf\n\
+  jio_fprintf = _jio_fprintf\n\
+  jio_snprintf = _jio_snprintf\n\
+  NewStringPlatform = _NewStringPlatform n\
+  VerifyClassCodesForMajorVersion = _VerifyClassCodesForMajorVersion\n\
+  VerifyClassCodes = _VerifyClassCodes\n\
+  _winFileHandleOpen\n\
+  winFileHandleOpen = _winFileHandleOpen\n\
+" >> $@
 
 clean::
Index: trunk/openjdk/jdk/make/java/jli/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/jli/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/jli/Makefile	(revision 447)
@@ -106,32 +106,32 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  _JLI_ParseManifest \n \
-  _JLI_JarUnpackFile \n \
-  _JLI_FreeManifest \n \
-  _JLI_ManifestIterate \n \
-  _JLI_ExactVersionId \n \
-  _JLI_PrefixVersionId \n \
-  _JLI_AcceptableRelease \n \
-  _JLI_ValidVersionString \n \
-  _JLI_WildcardExpandClasspath \n \
-  _JLI_MemAlloc \n \
-  _JLI_MemRealloc \n \
-  _JLI_StringDup \n \
-  _JLI_MemFree \n \
-  JLI_ParseManifest = _JLI_ParseManifest \n \
-  JLI_JarUnpackFile = _JLI_JarUnpackFile \n \
-  JLI_FreeManifest = _JLI_FreeManifest \n \
-  JLI_ManifestIterate = _JLI_ManifestIterate \n \
-  JLI_ExactVersionId = _JLI_ExactVersionId \n \
-  JLI_PrefixVersionId = _JLI_PrefixVersionId \n \
-  JLI_AcceptableRelease = _JLI_AcceptableRelease \n \
-  JLI_ValidVersionString = _JLI_ValidVersionString \n \
-  JLI_WildcardExpandClasspath = _JLI_WildcardExpandClasspath \n \
-  JLI_MemAlloc = _JLI_MemAlloc \n \
-  JLI_MemRealloc = _JLI_MemRealloc \n \
-  JLI_StringDup = _JLI_StringDup \n \
-  JLI_MemFree = _JLI_MemFree \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  _JLI_ParseManifest\n\
+  _JLI_JarUnpackFile\n\
+  _JLI_FreeManifest\n\
+  _JLI_ManifestIterate\n\
+  _JLI_ExactVersionId\n\
+  _JLI_PrefixVersionId\n\
+  _JLI_AcceptableRelease\n\
+  _JLI_ValidVersionString\n\
+  _JLI_WildcardExpandClasspath\n\
+  _JLI_MemAlloc\n\
+  _JLI_MemRealloc\n\
+  _JLI_StringDup\n\
+  _JLI_MemFree\n\
+  JLI_ParseManifest = _JLI_ParseManifest\n\
+  JLI_JarUnpackFile = _JLI_JarUnpackFile\n\
+  JLI_FreeManifest = _JLI_FreeManifest\n\
+  JLI_ManifestIterate = _JLI_ManifestIterate\n\
+  JLI_ExactVersionId = _JLI_ExactVersionId\n\
+  JLI_PrefixVersionId = _JLI_PrefixVersionId\n\
+  JLI_AcceptableRelease = _JLI_AcceptableRelease\n\
+  JLI_ValidVersionString = _JLI_ValidVersionString\n\
+  JLI_WildcardExpandClasspath = _JLI_WildcardExpandClasspath\n\
+  JLI_MemAlloc = _JLI_MemAlloc\n\
+  JLI_MemRealloc = _JLI_MemRealloc\n\
+  JLI_StringDup = _JLI_StringDup\n\
+  JLI_MemFree = _JLI_MemFree\n\
+" >> $@
 
 clean::
Index: trunk/openjdk/jdk/make/java/npt/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/npt/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/npt/Makefile	(revision 447)
@@ -76,8 +76,8 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  nptInitialize \n \
-  nptTerminate \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  nptInitialize\n\
+  nptTerminate\n\
+" >> $@
 
 clean::
Index: trunk/openjdk/jdk/make/java/zip/Makefile
===================================================================
--- trunk/openjdk/jdk/make/java/zip/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/java/zip/Makefile	(revision 447)
@@ -79,12 +79,12 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  ZIP_CRC32 = _ZIP_CRC32 \n \
-  ZIP_Open \n \
-  ZIP_Close \n \
-  ZIP_FindEntry \n \
-  ZIP_ReadEntry \n \
-  ZIP_GetNextEntry \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  ZIP_CRC32 = _ZIP_CRC32\n\
+  ZIP_Open\n\
+  ZIP_Close\n\
+  ZIP_FindEntry\n\
+  ZIP_ReadEntry\n\
+  ZIP_GetNextEntry\n\
+" >> $@
 clean::
 	-$(RM) $(DEF_FILE)
Index: trunk/openjdk/jdk/make/jpda/transport/shmem/Makefile
===================================================================
--- trunk/openjdk/jdk/make/jpda/transport/shmem/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/jpda/transport/shmem/Makefile	(revision 447)
@@ -84,7 +84,7 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  jdwpTransport_OnLoad \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  jdwpTransport_OnLoad\n\
+" >> $@
 
 clean::
Index: trunk/openjdk/jdk/make/jpda/transport/socket/Makefile
===================================================================
--- trunk/openjdk/jdk/make/jpda/transport/socket/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/jpda/transport/socket/Makefile	(revision 447)
@@ -98,7 +98,7 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  jdwpTransport_OnLoad \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  jdwpTransport_OnLoad\n\
+" >> $@
 
 clean::
Index: trunk/openjdk/jdk/make/sun/image/generic/Makefile
===================================================================
--- trunk/openjdk/jdk/make/sun/image/generic/Makefile	(revision 446)
+++ trunk/openjdk/jdk/make/sun/image/generic/Makefile	(revision 447)
@@ -61,13 +61,13 @@
 $(DEF_FILE): $(MAKEFILE_LIST)
 	@$(ECHO) "LIBRARY $(LIBRARY_NAME) INITINSTANCE TERMINSTANCE" > $@
-	@$(ECHO) 'EXPORTS \n \
-  j2d_mlib_ImageConvMxN = _j2d_mlib_ImageConvMxN \n \
-  j2d_mlib_ImageConvKernelConvert = _j2d_mlib_ImageConvKernelConvert \n \
-  j2d_mlib_ImageCreateStruct = _j2d_mlib_ImageCreateStruct \n \
-  j2d_mlib_ImageCreate = _j2d_mlib_ImageCreate \n \
-  j2d_mlib_ImageDelete = _j2d_mlib_ImageDelete \n \
-  j2d_mlib_ImageAffine = _j2d_mlib_ImageAffine \n \
-  j2d_mlib_ImageLookUp = _j2d_mlib_ImageLookUp \n \
-' >> $@
+	@$(ECHO) "EXPORTS\n\
+  j2d_mlib_ImageConvMxN = _j2d_mlib_ImageConvMxN\n\
+  j2d_mlib_ImageConvKernelConvert = _j2d_mlib_ImageConvKernelConvert\n\
+  j2d_mlib_ImageCreateStruct = _j2d_mlib_ImageCreateStruct\n\
+  j2d_mlib_ImageCreate = _j2d_mlib_ImageCreate\n\
+  j2d_mlib_ImageDelete = _j2d_mlib_ImageDelete\n\
+  j2d_mlib_ImageAffine = _j2d_mlib_ImageAffine\n\
+  j2d_mlib_ImageLookUp = _j2d_mlib_ImageLookUp\n\
+" >> $@
 
 clean::