Index: trunk/kBuild/sdks/NT4DDK.kmk
===================================================================
--- trunk/kBuild/sdks/NT4DDK.kmk	(revision 447)
+++ trunk/kBuild/sdks/NT4DDK.kmk	(revision 448)
@@ -27,5 +27,5 @@
 
 SDK_NT4DDK          := MicroSoft NT 4 DDK, X86
-PATH_SDK_NT4DDK     := $(PATH_DEV)/x86.win32/ddknt4
+PATH_SDK_NT4DDK     ?= $(PATH_DEV)/x86.win32/ddknt4
 PATH_SDK_NT4DDK_INC := $(PATH_SDK_NT4DDK)/inc
 PATH_SDK_NT4DDK_LIB := $(PATH_SDK_NT4DDK)/lib/i386/free
Index: trunk/kBuild/sdks/W2K3DDKAMD64.kmk
===================================================================
--- trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 447)
+++ trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 448)
@@ -27,5 +27,15 @@
 
 SDK_W2K3DDKAMD64          := MicroSoft Windows 2003 DDK, AMD64
+ifndef PATH_SDK_W2K3DDKAMD64
+PATH_SDK_W2K3DDKAMD64     := $(sort $(wildcard $(PATH_DEV)/amd64.win64/ddkwin2k3/2*))
+ifeq ($(PATH_SDK_W2K3DDKAMD64),)
+PATH_SDK_W2K3DDKAMD64     := $(sort $(wildcard $(PATH_DEV)/x86.win32/ddkwin2k3/2*))
+endif
+ifneq ($(PATH_SDK_W2K3DDKAMD64),)
+PATH_SDK_W2K3DDKAMD64     := $(call lastword,$(PATH_SDK_W2K3DDKAMD64))
+else
 PATH_SDK_W2K3DDKAMD64     := $(PATH_DEV)/x86.win32/ddkwin2k3
+endif
+endif
 PATH_SDK_W2K3DDKAMD64_INC := $(PATH_SDK_W2K3DDKAMD64)/inc
 PATH_SDK_W2K3DDKAMD64_LIB := $(PATH_SDK_W2K3DDKAMD64)/lib/wnet/AMD64
@@ -36,5 +46,6 @@
 	$(PATH_SDK_W2K3DDKAMD64_INC)/ddk/wnet \
 	$(PATH_SDK_W2K3DDKAMD64_INC)/wnet \
-	$(PATH_SDK_W2K3DDKAMD64_INC)/ddk/wdw/wnet
+	$(PATH_SDK_W2K3DDKAMD64_INC)/ddk/wdw/wnet \
+	$(PATH_SDK_W2K3DDKAMD64_INC)/crt
 
 SDK_W2K3DDKAMD64_LIBPATHS	:= $(PATH_SDK_W2K3DDKAMD64_LIB)
Index: trunk/kBuild/sdks/W2K3DDKX86.kmk
===================================================================
--- trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 447)
+++ trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 448)
@@ -27,5 +27,12 @@
 
 SDK_W2K3DDKX86          := MicroSoft Windows 2003 DDK, X86
+ifndef PATH_SDK_W2K3DDKX86
+PATH_SDK_W2K3DDKX86     := $(sort $(wildcard $(PATH_DEV)/x86.win32/ddkwin2k3/2*))
+ifneq ($(PATH_SDK_W2K3DDKX86),)
+PATH_SDK_W2K3DDKX86     := $(call lastword,$(PATH_SDK_W2K3DDKX86))
+else
 PATH_SDK_W2K3DDKX86     := $(PATH_DEV)/x86.win32/ddkwin2k3
+endif
+endif
 PATH_SDK_W2K3DDKX86_INC := $(PATH_SDK_W2K3DDKX86)/inc
 PATH_SDK_W2K3DDKX86_LIB := $(PATH_SDK_W2K3DDKX86)/lib/wnet/i386
@@ -36,5 +43,6 @@
 	$(PATH_SDK_W2K3DDKX86_INC)/ddk/wnet \
 	$(PATH_SDK_W2K3DDKX86_INC)/wnet \
-	$(PATH_SDK_W2K3DDKX86_INC)/ddk/wdm/wnet
+	$(PATH_SDK_W2K3DDKX86_INC)/ddk/wdm/wnet \
+	$(PATH_SDK_W2K3DDKX86_INC)/crt
 
 SDK_W2K3DDKX86_LIBPATHS	:= $(PATH_SDK_W2K3DDKX86_LIB)
Index: trunk/kBuild/sdks/W32API.kmk
===================================================================
--- trunk/kBuild/sdks/W32API.kmk	(revision 447)
+++ trunk/kBuild/sdks/W32API.kmk	(revision 448)
@@ -27,5 +27,13 @@
 
 SDK_W32API                  := MinGW Windows API
-PATH_SDK_W32API             ?= $(PATH_DEV)/x86.win32/w32api/v2.5
+ifndef PATH_SDK_W32API
+PATH_SDK_W32API             := $(sort $(wildcard $(PATH_DEV)/x86.win32/w32api/v*))
+ifneq ($(PATH_SDK_W32API),)
+PATH_SDK_W32API             := $(call lastword,$(PATH_SDK_W32API))
+else
+$(warning kBuild: PATH_SDK_W32API couldn't be determined!)
+PATH_SDK_W32API             := $(PATH_DEV)/x86.win32/w32api/not/found
+endif
+endif
 PATH_SDK_W32API_INC         := $(PATH_SDK_W32API)/include
 PATH_SDK_W32API_LIB         := $(PATH_SDK_W32API)/lib
Index: trunk/kBuild/sdks/WIN32SDK.kmk
===================================================================
--- trunk/kBuild/sdks/WIN32SDK.kmk	(revision 447)
+++ trunk/kBuild/sdks/WIN32SDK.kmk	(revision 448)
@@ -31,4 +31,7 @@
 ifneq ($(PATH_SDK_WIN32SDK),)
 PATH_SDK_WIN32SDK     := $(call lastword,$(PATH_SDK_WIN32SDK))
+else
+$(warning kBuild: PATH_SDK_WIN32SDK couldn't be determined!)
+PATH_SDK_WIN32SDK     := $(PATH_DEV)/x86.win32/sdk/not/found
 endif
 endif
Index: trunk/kBuild/sdks/WIN32SDK2002.kmk
===================================================================
--- trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 447)
+++ trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 448)
@@ -27,5 +27,16 @@
 
 SDK_WIN32SDK2002          := Win32 Platform SDK 2002
-PATH_SDK_WIN32SDK2002     ?= $(PATH_DEV)/x86.win32/sdk200209
+ifndef PATH_SDK_WIN32SDK2002
+PATH_SDK_WIN32SDK2002     := $(sort $(wildcard $(PATH_DEV)/x86.win32/sdk/2002*))
+ifeq ($(PATH_SDK_WIN32SDK2002),)
+PATH_SDK_WIN32SDK2002     := $(sort $(wildcard $(PATH_DEV)/x86.win32/sdk2002*))
+endif
+ifneq ($(PATH_SDK_WIN32SDK2002),)
+PATH_SDK_WIN32SDK2002     := $(call lastword,$(PATH_SDK_WIN32SDK2002))
+else
+$(warning kBuild: PATH_SDK_WIN32SDK2002 couldn't be determined!)
+PATH_SDK_WIN32SDK2002     := $(PATH_DEV)/x86.win32/sdk/not/found
+endif
+endif
 PATH_SDK_WIN32SDK2002_INC := $(PATH_SDK_WIN32SDK2002)/include
 PATH_SDK_WIN32SDK2002_LIB := $(PATH_SDK_WIN32SDK2002)/lib
Index: trunk/kBuild/sdks/WIN64SDK.kmk
===================================================================
--- trunk/kBuild/sdks/WIN64SDK.kmk	(revision 447)
+++ trunk/kBuild/sdks/WIN64SDK.kmk	(revision 448)
@@ -34,4 +34,7 @@
 ifneq ($(PATH_SDK_WIN64SDK),)
 PATH_SDK_WIN64SDK     := $(call lastword,$(PATH_SDK_WIN64SDK))
+else
+$(warning kBuild: PATH_SDK_WIN64SDK couldn't be determined!)
+PATH_SDK_WIN64SDK     := $(PATH_DEV)/amd64.win64/sdk/not/found
 endif
 endif
Index: trunk/kBuild/tools/VCC70.kmk
===================================================================
--- trunk/kBuild/tools/VCC70.kmk	(revision 447)
+++ trunk/kBuild/tools/VCC70.kmk	(revision 448)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Visual C++ 7.0 (aka Visual .NET)
 #
-# Copyright (c) 2004-2005 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
 #
 #
@@ -27,6 +27,11 @@
 
 TOOL_VCC70                    := Visual C++ 7.0
-PATH_TOOL_VCC70               ?= $(PATH_DEV)/x86.win32/vcc70
-PATH_TOOL_VCC70_LIB           ?= $(PATH_DEV)/x86.win32/vcc70/lib
+ifndef PATH_TOOL_VCC70
+PATH_TOOL_VCC70               := $(wildcard $(PATH_DEV)/x86.win32/vcc/v7)
+ifeq ($(PATH_TOOL_VCC70),)
+PATH_TOOL_VCC70               := $(PATH_DEV)/x86.win32/vcc70
+endif
+endif
+PATH_TOOL_VCC70_LIB           ?= $(PATH_TOOL_VCC70)/lib
 
 TOOL_VCC70_CC                 := $(EXEC_X86_WIN32) $(PATH_TOOL_VCC70)/bin/cl.exe